package com.LocalService;

import java.util.ArrayList;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.os.Binder;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Messenger;
import android.os.RemoteException;
import android.util.Log;
import android.widget.Toast;

public class MessengerService extends Service {

	private NotificationManager mNM;

	// иӵĿͻ
	ArrayList<Messenger> mClients = new ArrayList<Messenger>();
	// һθӵĿͻ˵ı־
	int mValue = 0;
	// עָMessage's replyTo ֵֶclient Messenger
	static final int MSG_REGISTER_CLIENT = 1;
	// ȡָMessage's replyTo ֵֶǰoMSG_REGISTER_CLIENTMessenger
	static final int MSG_UNREGISTER_CLIENT = 2;
	// ָڿͻ˺ͷֱӽ
	static final int MSG_SET_VALUE = 3;

	// ͻ˴͹Ϣ
	class IncomingHandler extends Handler {

		@Override
		public void handleMessage(Message msg) {

			switch (msg.what) {
			case MSG_REGISTER_CLIENT:
				// Optional Messenger where replies to this message can be sent.
				// The semantics of exactly how this is used are up to the
				// sender and receiver.
				mClients.add(msg.replyTo);
				break;
			case MSG_UNREGISTER_CLIENT:
				mClients.remove(msg.replyTo);
				break;
			case MSG_SET_VALUE:
				mValue = msg.arg1;
				for (int i = mClients.size() - 1; i >= 0; i--) {
					try {
						mClients.get(i).send(
								Message.obtain(null, MSG_SET_VALUE, mValue, 0));

					} catch (RemoteException e) {
						// Զ̿ͻ˳listƳ
						// бԱ֤ڲѭȫ
						mClients.remove(i);
					}
				}
				break;
			default:
				super.handleMessage(msg);

			}
			Log.i("Service", "" + mClients.size() + "ͻ");
		}
	}

	// һµMessengerѴڵHandler
	// κϢ͵MessengerHandler
	final Messenger mMessenger = new Messenger(new IncomingHandler());

	@Override
	public void onCreate() {
		mNM = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);

		// serviceʼʱiconͼŵ֪ͨ
		showNotification();
	}

	//
	private void showNotification() {
		CharSequence text = getText(R.string.local_service_started);

		Notification notification = new Notification(R.drawable.icon, text,
				System.currentTimeMillis());

		// ֪ͨʱcontentIntentactivity
		PendingIntent contentIntent = PendingIntent.getActivity(this, 0,
				new Intent(this, showActivity.class), 0);

		// ֪ͨʾ
		notification.setLatestEventInfo(this,
				getText(R.string.remote_service_label), text, contentIntent);

		mNM.notify(R.string.remote_service_started, notification);
	}
	//
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		Log.i("Service", "Received start id " + startId + ": " + intent);
		return START_STICKY;
	}

	@Override
	public void onDestroy() {
		mNM.cancel(R.string.remote_service_started);
		Toast.makeText(this, R.string.remote_service_stopped,
				Toast.LENGTH_SHORT).show();

	}

	@Override
	public IBinder onBind(Intent intent) {
		return mMessenger.getBinder();
	}

}